//+------------------------------------------------------------------+
//|                                                  cyclePeriod.mq4 |
//|                                      Copyright  2013, alToronto |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property copyright "alToronto"
#property link      "altoronto.com"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 DodgerBlue
//---- input parameters
extern int cyclePeriod = 14;
//---- buffers
double cycleBuffer[];
double velo1[];
double velo2[];
double velo3[];
double velo4[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;
//---- indicator line
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,cycleBuffer);
//---- name for DataWindow and indicator subwindow label
   short_name="Cycle Period ("+cyclePeriod+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);
//----
   SetIndexDrawBegin(0,cyclePeriod);
//----
   SetIndexBuffer(1, velo1);
   SetIndexBuffer(2, velo2);
   SetIndexBuffer(3, velo3);
   SetIndexBuffer(4, velo4);
   return(0);
  }
//+------------------------------------------------------------------+
//| Cycle Period                                                        |
//+------------------------------------------------------------------+
int start()
  {
   int i,counted_bars=IndicatorCounted();
//----
   if(Bars<=cyclePeriod) return(0);
//---- initial zero
   if(counted_bars<1)
      for(i=1;i<=cyclePeriod;i++) cycleBuffer[Bars-i]=0.0;
//----
   i=Bars-cyclePeriod-1;
   if(counted_bars>=cyclePeriod) i=Bars-counted_bars-1;
   while(i>=0)
     {
      velo1[i] = iMA(NULL, 0, cyclePeriod, 0, MODE_SMA, PRICE_CLOSE, i);
      velo2[i] = Close[i] - velo1[i];
      velo3[i] = velo2[i+1];
      velo4[i] = velo2[i] - velo3[i];
      //cycleBuffer[i] = iMA(NULL, 0, cyclePeriod/2, 0, MODE_SMA, PRICE_CLOSE, velo4[i]);
      
      //cycleBuffer[i] = Close[i] - velo1[i];
      cycleBuffer[i] = velo1[i];
      i--;
     }
   return(0);
  }
//+------------------------------------------------------------------+